
/* Chrysalide - Outil d'analyse de fichiers binaires
 * browser-int.h - prototypes internes pour le parcours des résultats d'analyse Kaitai pour ROST
 *
 * Copyright (C) 2023 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Chrysalide.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef PLUGINS_KAITAI_ROST_BROWSER_INT_H
#define PLUGINS_KAITAI_ROST_BROWSER_INT_H


#include <analysis/scan/item-int.h>


#include "browser.h"



/* Parcours des résultats d'une analyse Kaitai pour ROST (instance) */
struct _GKaitaiBrowser
{
    GScanRegisteredItem parent;             /* A laisser en premier        */

    char *path;                             /* Chamin vers l'enregistrement*/
    GMatchRecord *record;                   /* Correspondance à parcourir  */

};

/* Parcours des résultats d'une analyse Kaitai pour ROST (classe) */
struct _GKaitaiBrowserClass
{
    GScanRegisteredItemClass parent;        /* A laisser en premier        */

};


/* Met en place un nouveau parcours de correspondances Kaitai. */
bool g_kaitai_browser_create(GKaitaiBrowser *, const char *, GMatchRecord *);



#endif  /* PLUGINS_KAITAI_ROST_BROWSER_INT_H */
