
/* Chrysalide - Outil d'analyse de fichiers binaires
 * trigger.h - prototypes pour l'accès à des définitions Kaitai depuis ROST
 *
 * Copyright (C) 2023 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Chrysalide.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef PLUGINS_KAITAI_ROST_TRIGGER_H
#define PLUGINS_KAITAI_ROST_TRIGGER_H


#include <glib-object.h>


#include <analysis/scan/item.h>


#include "../parsers/struct.h"



#define G_TYPE_KAITAI_TRIGGER            g_kaitai_trigger_get_type()
#define G_KAITAI_TRIGGER(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), G_TYPE_KAITAI_TRIGGER, GKaitaiTrigger))
#define G_IS_KAITAI_TRIGGER(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), G_TYPE_KAITAI_TRIGGER))
#define G_KAITAI_TRIGGER_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_KAITAI_TRIGGER, GKaitaiTriggerClass))
#define G_IS_KAITAI_TRIGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_KAITAI_TRIGGER))
#define G_KAITAI_TRIGGER_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_KAITAI_TRIGGER, GKaitaiTriggerClass))


/* Accès à une définition et déclenchement d'une analyse Kaitai depuis ROST (instance) */
typedef struct _GKaitaiTrigger GKaitaiTrigger;

/* Accès à une définition et déclenchement d'une analyse Kaitai depuis ROST (classe) */
typedef struct _GKaitaiTriggerClass GKaitaiTriggerClass;


/* Indique le type défini pour un accès à une définition Kaitai pour ROST. */
GType g_kaitai_trigger_get_type(void);

/* Crée un nouvel accès à une définition Kaitai à instancier. */
GScanRegisteredItem *g_kaitai_trigger_new(GKaitaiStruct *);



#endif  /* PLUGINS_KAITAI_ROST_TRIGGER_H */
